/**
* Copyright (c) 2010, Leonardo R. Bachega and Charles A. Bouman
* All rights reserved.
* 
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the Purdue University nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
* 
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL Leonardo R. Bachega and Charles A. Bouman BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**/
import java.util.*;
public class CostComparator implements Comparator<Integer>{
	FastSMT smt;
	int k;
/*
	public CostComparator (int k, FastSMT2 smt)
	{
		init (k, (FastSMT) smt);
	}
	
	public CostComparator (int k, FastSMT3 smt)
	{
		init (k, (FastSMT) smt);
	}
*/
	public CostComparator (int k, FastSMT4 smt)
	{
		init (k, (FastSMT) smt);
	}
	void init (int k, FastSMT smt)
	{
		this.k = k;
		this.smt = smt;
	}

	public int compare (Integer i, Integer j)
	{	
		double cost_ki = this.smt.Cost(i, this.k);
		double cost_kj = this.smt.Cost(this.k, j);
		/*
		 * Note that it returns the reverse order since we need to sort the list of neighbors in reverse order 
		 */
		if (cost_ki > cost_kj) 
			return -1;	
		if (cost_kj > cost_ki) 
			return 1;
		
	
		return 0;
	}
}
