/**
* Copyright (c) 2010, Leonardo R. Bachega and Charles A. Bouman
* All rights reserved.
* 
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the Purdue University nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
* 
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL Leonardo R. Bachega and Charles A. Bouman BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**/

public class Rotation {
	int i,j;
	double theta;
	public Rotation(int i, int j, double theta)
	{
		this.i = i;
		this.j = j;
		this.theta = theta;
	}
	public void print()
	{
		System.out.println("("+i+","+j+") "+theta);
	}
	
	public String printToString()
	{
		String p = String.valueOf(i)+" "+String.valueOf(j)+" "+String.valueOf(theta);
		return p;
	}
	
	public int getIk()
	{
		return i;
	}
	public int getJk()
	{
		return j;
	}
	public double getTheta()
	{
		return theta;
	}
	public double getCosTheta()
	{
		return Math.cos(theta);
	}
	public double getSinTheta()
	{
		return Math.sin(theta);
	}
}
